## libioth 0.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project("libioth"
		DESCRIPTION "Internet of Threads library"
		HOMEPAGE_URL "https://github.com/virtualsquare/libioth"
    VERSION 0.1.0
    LANGUAGES C)

include(GNUInstallDirs)
include(CheckIncludeFile)
include(CheckSymbolExists)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FORTIFY_SOURCE=2 -O2 -pedantic -Wall -Wextra")
set(SYSTEM_IOTH_PATH ${CMAKE_INSTALL_FULL_LIBDIR}/ioth)

set(LIBS_REQUIRED fduserdata vdeplug mhash)
set(HEADERS_REQUIRED nlinline+.h fduserdata.h libvdeplug.h mhash.h)
set(CMAKE_REQUIRED_QUIET TRUE)

foreach(THISLIB IN LISTS LIBS_REQUIRED)
  find_library(LIB${THISLIB}_OK ${THISLIB})
  if(NOT LIB${THISLIB}_OK)
    message(FATAL_ERROR "library lib${THISLIB} not found")
  endif()
endforeach(THISLIB)

foreach(HEADER IN LISTS HEADERS_REQUIRED)
  check_include_file(${HEADER} ${HEADER}_OK)
  if(NOT ${HEADER}_OK)
    message(FATAL_ERROR "header file ${HEADER} not found")
  endif()
endforeach(HEADER)

add_definitions(-D_GNU_SOURCE)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(ioth SHARED ioth.c ioth_getifaddrs.c checklicense.c)
target_link_libraries(ioth dl fduserdata)
set_target_properties(ioth PROPERTIES VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR})
install(TARGETS ioth DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ioth.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

add_library(iothaddr SHARED iothaddr.c)
target_link_libraries(iothaddr mhash)
set_target_properties(iothaddr PROPERTIES VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR})
install(TARGETS iothaddr DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES iothaddr.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

configure_file(config.h.in config.h)

add_subdirectory(test)
add_subdirectory(modules)
add_subdirectory(man)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${PROJECT_SOURCE_DIR}/Uninstall.cmake")

=== modules/CMakeLists.txt ===
add_library(ioth_kernel-r SHARED ioth_kernel.c)
set_target_properties(ioth_kernel-r PROPERTIES PREFIX "")
install(TARGETS ioth_kernel-r DESTINATION ${SYSTEM_IOTH_PATH})
ADD_CUSTOM_TARGET(ioth_kernel_n.so ALL DEPENDS ioth_kernel-r
	COMMAND ${CMAKE_COMMAND} -E create_symlink ioth_kernel-r.so ioth_kernel_n.so)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ioth_kernel_n.so DESTINATION ${SYSTEM_IOTH_PATH})

add_library(ioth_vdestack-r SHARED ioth_vdestack.c)
set_target_properties(ioth_vdestack-r PROPERTIES PREFIX "")
target_link_libraries(ioth_vdestack-r vdeplug -lpthread)

install(TARGETS ioth_vdestack-r DESTINATION ${SYSTEM_IOTH_PATH})
ADD_CUSTOM_TARGET(ioth_vdestack_n.so ALL DEPENDS ioth_vdestack-r
	COMMAND ${CMAKE_COMMAND} -E create_symlink ioth_vdestack-r.so ioth_vdestack_n.so)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ioth_vdestack_n.so DESTINATION ${SYSTEM_IOTH_PATH})

=== test/CMakeLists.txt ===
add_executable(iothtest_server iothtest_server.c)
target_link_libraries(iothtest_server ioth pthread)

add_executable(iothtest_client iothtest_client.c)
target_link_libraries(iothtest_client ioth pthread)

=== debian/changelog ===
libioth (0.1.2-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:07:04 +0000

libioth (0.1.2-3build1) noble; urgency=medium

  * No-change rebuild against libvdeplug2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 05:59:48 +0000

libioth (0.1.2-3) unstable; urgency=medium

  * Fix build on non amd64 architecture

 -- Andrea Capriotti <capriott@debian.org>  Thu, 11 Jan 2024 01:53:09 +0100

libioth (0.1.2-2) unstable; urgency=medium

  * d/control: Add libmhash-dev Build-Depends

 -- Andrea Capriotti <capriott@debian.org>  Thu, 11 Jan 2024 00:15:27 +0100

libioth (0.1.2-1) unstable; urgency=medium

  * Initial Debian release (Closes: #1058963)

 -- Andrea Capriotti <capriott@debian.org>  Tue, 09 Jan 2024 22:19:53 +0100

libioth (0.1.1-1) unstable; urgency=medium

  * d/control: Add nlinline-dev Build-Depends
  * d/control: Add Uploaders, Vcs-Browser and Vcs-Git
  * d/copyright: Update Debian copyright

 -- Andrea Capriotti <capriott@debian.org>  Tue, 09 Jan 2024 20:47:05 +0100

libioth (0.1-1) unstable; urgency=low

  * Initial release. (tnx Gabriele Aprile, Federico Borci)

 -- Renzo Davoli <renzo@cs.unibo.it>  Mon, 26 Jun 2023 13:58:02 +0200

=== debian/control ===
Source: libioth
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
Uploaders: Mattia Biondi <mattiabiondi1@gmail.com>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
Build-Depends: debhelper-compat (= 13), cmake (>= 3.12), libvdeplug-dev, libfduserdata-dev, nlinline-dev, libmhash-dev
Standards-Version: 4.6.2
Homepage: http://www.virtualsquare.org/
Vcs-Browser: https://salsa.debian.org/virtualsquare-team/libioth
Vcs-Git: https://salsa.debian.org/virtualsquare-team/libioth.git
Rules-Requires-Root: no

Package: libioth-dev
Section: libdevel
Architecture: any
Depends: libioth0 (= ${binary:Version}), ${misc:Depends}
Description: Unified API for the Internet of Threads - development
 libioth main goal is to provide a convenient API
 to interoperate with different network stack implementations.
 Libioth is also an infrastructure where the actual
 implementations can be loaded as plug-ins.
 Libioth's API is minimal: it includes the complete set of
 Berkeley Sockets functions, some functions to add or delete
 a stack and 'msocket', an extended version of 'socket' providing
 one more leading argument to select which stack should
 manage the communication.
 .
 This package contains the development files used for libioth.

Package: libioth0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Unified API for the Internet of Threads - library
 libioth main goal is to provide a convenient API
 to interoperate with different network stack implementations.
 Libioth is also an infrastructure where the actual
 implementations can be loaded as plug-ins.
 Libioth's API is minimal: it includes the complete set of
 Berkeley Sockets functions, some functions to add or delete
 a stack and 'msocket', an extended version of 'socket' providing
 one more leading argument to select which stack should
 manage the communication.
 .
 This package contains the library.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_install:
	dh_auto_install --destdir debian/tmp
